#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif !EXEC_TYPES_H

#ifdef BUILTIN
#define strlen __builtin_strlen
#define strcmp __builtin_strcmp
#define strcpy __builtin_strcpy
#define memset __builtin_memset
#define memcmp __builtin_memcmp
#define memcpy __builtin_memcpy
#endif

#ifndef BUILTIN
long __asm strlen( register __a0 const char *_s);	/* Builtin */
long int __asm strcmp( register __a0 const char *_s1, register __a1 const char *_s2);
char * __asm strcpy( register __a0 char *_dst, register __a1 const char *_src);

void * __asm memset( register __a0 void *_s, register __d0 int _c, register __d1 unsigned long _n);
/*
 *
 * memset() copies the value of c into the first , bytes of object
 * pointed by _s
 */
long int __asm memcmp( register __a0 const void *_s1, register __a1 const void *_s2, register __d0 unsigned long _n);
void * __asm memcpy( register __a0 void *_dst, register __a1 const void *_src, register __d0 unsigned long _n);
/*	this is a stub to the CopyMem() exec function which do this ! */
#endif

void * __asm memchr(register __a0 const void *_s, register __d0 int _c, register __d2 unsigned long _n);
/*
 * memchr search the first n bytes in the object pointed to by
 * _s for the caracter c. if c is found, memchr() return a pointer
 * to it. Otherwise, a NULL ponter is returned.
 *
 */

char * __asm strncpy( register __a0 char *_dst, register __a1 const char *_src, register __d1 unsigned long _n);
/*
 * strncpy() copies a maximum of _n character from the string
 * pointed to by _src to the area pointedti by _dest. if _src is less than
 * _n characer long, then _dest is padded whith null characters
 * untils _n total character have been writeen. The area pointed
 * to by _dest muste be at least _n charaters in lenght
 */
char * __asm strncat( register __a0 char *_dst, register __a1 const char *_src, register __d0 unsigned long _n);
/*
 * strncat() append a copy of the string pointed to by _src to the 
 * sring pointed to by _dst until either _n character have been
 * append or a null is reached in src, whichever come first.
 * strncat() always return a pointer to dest.
 */
char * __asm strcat( register __a0 char *_dst, register __a1 const char *_src);

long int __asm strncmp( register __a0 const char *_s1, register __a1 const char *_s2, register __d0 unsigned long _n);

char * __asm strchr( register __a0 const char *_s, register __d0 int _c);
/*
 * strchr search in the string pointed to by
 * _s for the caracter c. if c is found, strchr() return a pointer
 * to it. Otherwise, a NULL ponter is returned.
 *
 */
char * __asm strstr( register __a0 char *_s1, register __a1 char *_s2);
/*
 * strstr() return the first occurence id the substring _s2
 * contained whithin the string _s1. if the _s2 is not contained whithin _s1
 * the NULL is returned
 */

/*
 * NO CASE sensitive cmp.
 * don't forget that this function exist in the wanderfull Arp as Strcmp() and Strncmp()
 */
long int __asm stricmp( register __a0 const char *_s1, register __a1 const char *_s2);
long int __asm strnicmp( register __a0 const char *_s1, register __a1 const char *_s2, register __d0 unsigned long _n);

BOOL isalpha(char _c);
BOOL isupper(char _c);
BOOL islower(char _c);
BOOL isdigit(char _c);
BOOL isxdigit(char _c);
BOOL isalnum(char _c);
BOOL isspace(char _c);
BOOL ispunct(char _c);
BOOL iscntrl(char _c);
BOOL isprint(char _c);
BOOL isgraph(char _c);
BOOL isascii(char _c);
BOOL tolower(char _c);
BOOL toupper(char _c);

